package fi.em.opplugin;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

/**
 * @author cjz
 * @date 2024/8/20 9:01
 * @description:薪酬计提单，审核后自动带出审核人和审核日期
 */
public class SalaryDistributeOpPlugin extends AbstractOperationServicePlugIn  {

    private static String nckd_salarydistribute="nckd_salarydistribute";//薪酬计提单标识
    private static String audit="audit";//审核操作标识



    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs args){
        DynamicObject[] dynamicObjects = args.getDataEntities();
        for(int i=0;i< dynamicObjects.length;i++) {
            String billno=dynamicObjects[i].getString("billno");
            //根据单据号查询
            QFilter filter=new QFilter("billno", QCP.equals, billno);
            DynamicObject nckd_salary = BusinessDataServiceHelper.
                    loadSingle(nckd_salarydistribute, "id,number,billno,nckd_auditor", new QFilter[]{filter});
            //设置审核人
            nckd_salary.set("nckd_auditor",RequestContext.get().getUserId());
            SaveServiceHelper.save(new DynamicObject[]{nckd_salary});
        }
    }


}
