package fi.em.service;


import kd.bos.dataentity.entity.DynamicObject;

import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.mvc.bill.BillModel;
import kd.fi.er.business.daily.reimburse.AmountObject;
import kd.fi.er.mservice.ext.IErService4Ext;

import java.math.BigDecimal;

/**
 * @author cjz
 * @date 2024/8/14 17:08
 * @description:付现金额计算
 * loanType：冲销类型 1=原币冲销 ，2=本位币冲销
 * oriPayAmount：标准产品计算出的付现金额
 * curPayAmount：标准产品计算出的付现金额（本位币）
 */
public class PayamountCalcExt {
    public static String nckd_er_tripreimburse_ext="nckd_er_tripreimburse_ext";//差旅报销单标识
    public AmountObject payamountCalc(BillModel model, String loanType, BigDecimal oriPayAmount, BigDecimal curPayAmount) {
        String dateType = model.getDataEntityType().getName();
        BigDecimal orgamount_all = new BigDecimal(0);
        if("er_tripreimbursebill".equals(dateType)){
            //冲销金额总数
            BigDecimal orgiexpebalanceamount_sum = new BigDecimal("0");
            //获取冲预付借款分录
            DynamicObjectCollection entryCol = (DynamicObjectCollection) model.getValue("nckd_clearloanentry");
            for(DynamicObject entryObj : entryCol){
                //冲销金额
                BigDecimal orgiexpebalanceamount=entryObj.getBigDecimal("nckd_unexporiusedamount");
                //冲销金额累加计算
                orgiexpebalanceamount_sum=orgiexpebalanceamount_sum.add(orgiexpebalanceamount);
            }
            //冲销总金额
            orgamount_all=orgiexpebalanceamount_sum;
        }
        //减冲销金额总和
        curPayAmount=curPayAmount.subtract(orgamount_all);
        return new AmountObject(curPayAmount,curPayAmount);
    }
}
