package fi.er.opplugin;

import com.alibaba.druid.util.StringUtils;
import fi.cas.common.SettlementStatusEnum;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;

//合同台账单
public class ContractBillOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        //获取合同台账单据信息
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            if (StringUtils.equals(e.getOperationKey(),"audit")) {
                //当前单头数据包
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                BigDecimal orinotpayamount = info.getBigDecimal("orinotpayamount");
                info.set("nckd_unsettleamount",orinotpayamount);
                info.set("nckd_settleamount",BigDecimal.ZERO);
                info.set("nckd_settlestatus", SettlementStatusEnum.未结算.getValue());
                SaveServiceHelper.save(new DynamicObject[]{info});
            } else if (StringUtils.equals(e.getOperationKey(),"unaudit")) {
                //当前单头数据包
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                info.set("nckd_unsettleamount",BigDecimal.ZERO);
                info.set("nckd_settlestatus", null);
                SaveServiceHelper.save(new DynamicObject[]{info});
            }
        }
    }
}
