package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

//资产拆分单
public class AssetSplitBillOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            if (StringUtils.equals(e.getOperationKey(), "audit")) {
                //审核通过后反写e管家实物卡片清单
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                for (DynamicObject dynamicObject : info.getDynamicObjectCollection("subassetsplitentry")) {
                    String number = dynamicObject.getString("aft_cardnumber");//资产编码
                    DynamicObject card = dynamicObject.getDynamicObject("nckd_real_card_list");//e管家实物卡片清单字段
                    Long id = card.getLong("id");
                    //查询e管家实物卡片清单
                    QFilter filter = new QFilter("id", QCP.equals,id);
                    DynamicObject[] cardObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                    for (int j = 0; j < cardObjects.length; j++) {
                        DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(cardObjects[j].getPkValue(), cardObjects[j].getDynamicObjectType().getName());
                        //更新星瀚实物编码字段
                        cardInfo.set("nckd_card_real_code", number);
                        SaveServiceHelper.save(new DynamicObject[]{cardInfo});
                    }
                }
            }
        }
    }
}
