package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

//业务处理单
public class BusProcessBillOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            if (StringUtils.equals(e.getOperationKey(),"audit")) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                if ("D".equals(info.getString("nckd_detailtype"))) {
                    for (DynamicObject nckd_entryentity6 : info.getDynamicObjectCollection("nckd_entryentity6")) {
                        String  number = nckd_entryentity6.getDynamicObject("nckd_basedatafield").getString("number");
                        if (!StringUtils.isEmpty(number)) {
                            //查询e管家实物卡片清单
                            QFilter filter = new QFilter("nckd_card_real_code", QCP.equals,number);
                            DynamicObject[] cardObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                            for (int j = 0; j < cardObjects.length; j++) {
                                DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(cardObjects[j].getPkValue(), cardObjects[j].getDynamicObjectType().getName());
                                //回写e管家实物清单字段
                                cardInfo.set("nckd_discard", "1");//是否报废
                                SaveServiceHelper.save(new DynamicObject[]{cardInfo});
                            }
                        }

                    }
                }
            }
            else if (StringUtils.equals(e.getOperationKey(),"unaudit")) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                if ("D".equals(info.getString("nckd_detailtype"))) {
                    for (DynamicObject nckd_entryentity6 : info.getDynamicObjectCollection("nckd_entryentity6")) {
                        String  number = nckd_entryentity6.getDynamicObject("nckd_basedatafield").getString("number");
                        if (!StringUtils.isEmpty(number)) {
                            //查询e管家实物卡片清单
                            QFilter filter = new QFilter("nckd_card_real_code", QCP.equals,number);
                            DynamicObject[] cardObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                            for (int j = 0; j < cardObjects.length; j++) {
                                DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(cardObjects[j].getPkValue(), cardObjects[j].getDynamicObjectType().getName());
                                //回写e管家实物清单字段
                                cardInfo.set("nckd_discard", "0");//是否报废
                                SaveServiceHelper.save(new DynamicObject[]{cardInfo});
                            }
                        }

                    }
                }
            }
        }
    }
}
