package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

//资产调出单
public class FaDispatchBillOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            if (StringUtils.equals(e.getOperationKey(),"audit")) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                //审批通过，若关联e管家实物卡片清单，更新调入组织，调入部门，使用人
                for (DynamicObject dispatchentry : info.getDynamicObjectCollection("dispatchentry")) {
                    DynamicObject realcard = dispatchentry.getDynamicObject("realcard");
                    String number = realcard.getString("number");
                    //查询实物卡片清单
                    QFilter filter = new QFilter("nckd_card_real_code", QCP.equals,number);
                    DynamicObject[] cardObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                    for (int j = 0; j < cardObjects.length; j++) {
                        DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(cardObjects[j].getPkValue(), cardObjects[j].getDynamicObjectType().getName());
                        //回写e管家实物清单字段
                        cardInfo.set("nckd_orgfield", info.getDynamicObject("inassetunit").getLong("id"));//归属组织
                        if (dispatchentry.getDynamicObject("inusedept") != null) {
                            cardInfo.set("nckd_dept", dispatchentry.getDynamicObject("inusedept").getLong("id"));//归属部门
                        }
                        SaveServiceHelper.save(new DynamicObject[]{cardInfo});
                    }
                }
            }
            if (StringUtils.equals(e.getOperationKey(),"unaudit")) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                //审批通过，若关联e管家实物卡片清单，更新调入组织，调入部门，使用人
                for (DynamicObject dispatchentry : info.getDynamicObjectCollection("dispatchentry")) {
                    DynamicObject realcard = dispatchentry.getDynamicObject("realcard");
                    String number = realcard.getString("number");
                    //查询实物卡片清单
                    QFilter filter = new QFilter("nckd_card_real_code", QCP.equals,number);
                    DynamicObject[] cardObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                    for (int j = 0; j < cardObjects.length; j++) {
                        DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(cardObjects[j].getPkValue(), cardObjects[j].getDynamicObjectType().getName());
                        //还原e卡片实物清单字段
                        cardInfo.set("nckd_orgfield", info.getDynamicObject("assetunit").getLong("id"));//归属组织
                        cardInfo.set("nckd_dept", dispatchentry.getDynamicObject("realcard").getDynamicObject("headusedept").getLong("id"));//归属部门
                        SaveServiceHelper.save(new DynamicObject[]{cardInfo});
                    }
                }
            }
        }
    }
}
