package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;


import java.util.EventObject;

//资产拆分单
public class RealCardSplitF7OpPlugin extends AbstractFormPlugin implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
    }
    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {

    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String fieldKey = e.getProperty().getName();
        if (StringUtils.equals("split_realcard", fieldKey)) {
            //获取变更的数据
            ChangeData changeData = e.getChangeSet()[0];
            DynamicObject dynamicObject = (DynamicObject) changeData.getNewValue();
            if (dynamicObject != null) {
                String number = dynamicObject.getString("number");
                //查询e管家实物卡片清单
                QFilter filter = new QFilter("nckd_card_real_code", QCP.equals,number);
                DynamicObject[] cardDynamicObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                if (cardDynamicObjects.length > 1) {
                    this.getModel().setValue("splitqty", cardDynamicObjects.length);
                    this.getModel().setValue("nckd_e_flag", "1");
                }else {
                    this.getModel().setValue("nckd_e_flag", null);
                }
            }
        }
    }
}
