package kd.imc.rim.utils;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.script.annotations.KSObject;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;

import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Base64;
import java.util.Date;
import java.util.Iterator;


@KSObject
public class ApiHttpUtils {

    public static String Posthttp(String url, String Params) throws Exception {
        // 获得Http客户端
        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        // 创建Post请求
        //设置请求路径
        HttpPost httpPost = new HttpPost(url);
        httpPost.setHeader("Content-type", "application/json;charset=utf-8");
        httpPost.setHeader("mesgtype", "bills_crop_base64");
        httpPost.setHeader("channelcode", "JSX");
        Date date = new Date();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        String formatDate = dateFormat.format(date);
        httpPost.setHeader("channeldate", formatDate);
        long time = new Date().getTime();
        String channeltime = Long.toString(time);
        httpPost.setHeader("channeltime",channeltime);
        long l = System.currentTimeMillis();
        String channelserno = Long.toString(l);
        httpPost.setHeader("channelserno", channelserno);
        httpPost.setHeader("brno", "");
        httpPost.setHeader("tellerno", "*DMY");
        httpPost.setHeader("terminalno", "");
        httpPost.setHeader("APP_", "");
        httpPost.setHeader("reserve", "");
        httpPost.setHeader("dealcode", "");
        httpPost.setHeader("dealmsg", "");
        httpPost.setHeader("App_key", "XYK_DPJ_KEY");
        httpPost.setHeader("App_secret", "XYK_DPJ_SECRET");
        JSONObject object = new JSONObject();
        object.put("file_base64",Params);
        StringEntity entity = new StringEntity(object.toString(), ContentType.APPLICATION_JSON);
        // post请求是将参数放在请求体里面传过去的;这里将entity放入post请求体中
        // 设置编码格式
//        entity.setContentEncoding("UTF-8");
        // 发送Json格式的数据请求
//        entity.setContentType("application/json");
        httpPost.setEntity(entity);
        // 响应模型（发送post请求）
        CloseableHttpResponse response = httpClient.execute(httpPost);
        // 从响应模型中获取响应实体
        HttpEntity responseEntity = response.getEntity();
        com.alibaba.fastjson.JSONObject jsonObject = new com.alibaba.fastjson.JSONObject();
        if (responseEntity != null) {
            jsonObject = JSON.parseObject(EntityUtils.toString(response.getEntity()));
            return jsonObject.toJSONString();
        }
        // 释放资源
        if (httpClient != null) {
            httpClient.close();
        }
        if (response != null) {
            response.close();
        }
        return "";
    }

    public static String HttpPostExample () {
        try { // 图片路径
             String imagePath = "path_to_your_image_file.jpg";
            // 将图片转换为Base64编码
             byte[] imageBytes = java.nio.file.Files.readAllBytes(java.nio.file.Paths.get(imagePath));
            String base64Image = Base64.getEncoder().encodeToString(imageBytes);
            // 创建URL对象
            URL url = new URL("http://10.3.2.70:8115");
             //打开HTTP连接
             HttpURLConnection connection = (HttpURLConnection) url.openConnection();
             connection.setRequestMethod("POST");
             connection.setRequestProperty("Content-Type", "application/json");
             connection.setRequestProperty("channelcode", "your_channel_code");
             connection.setRequestProperty("channeldate", "your_channel_date");
             connection.setDoOutput(true); // 将Base64编码的图片作为请求体发送
             try (OutputStream os = connection.getOutputStream())
             { os.write(base64Image.getBytes()); os.flush(); }
             //检查响应代码
             int responseCode = connection.getResponseCode();
             if (responseCode == HttpURLConnection.HTTP_OK) {
             System.out.println("Request was successful.");
             } else { System.out.println("Request failed. Response Code: " + responseCode); }
            // 关闭连接
            connection.disconnect(); }
             catch (Exception e) { e.printStackTrace(); }
        return null;
    }
    public static String toJsonString(String Params) throws Exception {
        if("".equals(Params)){return null;};
        JSONArray objects = JSONArray.parseArray(Params);
        Object object = objects.get(0);
        JSONObject respenjson = (JSONObject) JSONObject.toJSON(object);
        JSONArray itemList = respenjson.getJSONArray("item_list");
        JSONObject item_list = new JSONObject();
        for (int i=0;i<itemList.size();i++){
            Object obj = itemList.get(i);
            JSONObject respenjsons = (JSONObject) JSONObject.toJSON(obj);


        }

        JSONObject json = new JSONObject();//返回最外层json
        json.put("errcode","0000");
        json.put("traceId","");
        json.put("description","操作成功");
        JSONObject data = new JSONObject();//数据层json
        json.put("batchNo","");
        JSONArray recoginitionData = new JSONArray();//数据层数组
        JSONObject fileObj = new JSONObject();//实际数据json
        fileObj.put("canBeDeduction","");//0
        fileObj.put("salerName","");//销售方名称  ocr字段：vat_invoice_seller_name
        fileObj.put("invoiceMoney","");//金额明细 ocr字段：vat_invoice_price_list
        fileObj.put("signStatus","");//0
        fileObj.put("downloadUrl","");//下载地址链接
        fileObj.put("fileHash","");//文件哈希值
        fileObj.put("invoiceAmount","");//合计金额 ocr字段：vat_invoice_total
        fileObj.put("localUrl","");//预览链接
        fileObj.put("deductionStatus",1);//扣除
        fileObj.put("salerTaxNo","");//纳税人识别号 ocr字段：vat_invoice_seller_id_invoice_seal
        fileObj.put("invoiceType",1);//发票类型 ocr字段：type  1="增值税发票"
        fileObj.put("invoiceNo","");//发票号码 ocr字段：vat_invoice_haoma_large_size
        fileObj.put("isRepeat",false);//是否重复
        fileObj.put("pixel","");//3962978 未知字段
        fileObj.put("oriImageSize","");//base64编码长度
        fileObj.put("pdfToImgSnapshotUrl","");//空
        fileObj.put("orientation","0");//0
        fileObj.put("batchNo",null);//null
        fileObj.put("clientId","Vfz636yVhmk9HEu1QTAp");//客户端id
        fileObj.put("buyerTaxNo","");//购买方纳税人识别号 ocr字段：vat_invoice_rate_payer_id
        fileObj.put("warningCode","");//警告数量
        fileObj.put("originalState",0);//原始状态0
        fileObj.put("companySeal","1");//未知字段
        fileObj.put("originalUrl","");//地址链接
        fileObj.put("invoiceDate","");//开票日期 ocr字段：vat_invoice_issue_dat_print
        fileObj.put("buyerName","");//购买方名称  ocr字段：vat_invoice_payer_name
        fileObj.put("invoiceCode","");//发票代码 ocr字段： vat_invoice_daima
        fileObj.put("serialNo","");//未知字段
        fileObj.put("totalAmount","");//价税合计 ocr字段： vat_invoice_total_cover_tax_digits
        fileObj.put("taxRate","");//税率 ocr字段 vat_invoice_tax_rate
        fileObj.put("oriOrientation","0");//未知字段
        fileObj.put("oriRegion","");//什么地区....
        fileObj.put("rotationAngle","0");//未知字段
        fileObj.put("snapshotUrl","");//图片地址
        fileObj.put("imageSerialNo","");//图片编码?
        fileObj.put("recognitionSerialNo","");//未知字段
        fileObj.put("totalTaxAmount","");//税额合计 ocr字段 vat_invoice_tax_total
        fileObj.put("taxAmount","");//税额 ocr字段 vat_invoice_tax_list
        fileObj.put("region","");//未知字段
        fileObj.put("isExpend","");//""
        fileObj.put("expendStatus",null);//null
        fileObj.put("fileType",1);//附件类型
        JSONArray items = new JSONArray();//数据明细层数组
        JSONObject mxFileObj = new JSONObject();//明细数据json
        mxFileObj.put("unitPrice","");//合计金额 oct字段： vat_invoice_total
        mxFileObj.put("taxRate","");//税率明细 vat_invoice_tax_rate_list
        mxFileObj.put("unit","");
        mxFileObj.put("num","1");
        mxFileObj.put("detailAmount","");//金额明细 ocr字段：vat_invoice_price_list
        mxFileObj.put("taxAmount","");//税额明细 ocr字段 vat_invoice_tax_list
        mxFileObj.put("goodsName","");//服务名称/项目名称 ocr字段 vat_invoice_goods_list
        //值拼接完成后开始set数据结构
        items.add(mxFileObj);
        fileObj.put("items",items);
        recoginitionData.add(fileObj);
        data.put("recoginitionData",recoginitionData);
        json.put("data",data);
        return json.toJSONString();
    }
}
