//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package kd.imc.rim;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Maps;
import java.io.ByteArrayInputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.util.StringUtils;
import kd.imc.rim.common.constant.InputInvoiceTypeEnum;
import kd.imc.rim.common.invoice.model.ConvertFieldUtil;
import kd.imc.rim.common.invoice.query.convert.impl.AirConvertService;
import kd.imc.rim.common.invoice.recognitionnew.RecognitionService;
import kd.imc.rim.common.invoice.recognitionnew.model.RecognitionParam;
import kd.imc.rim.common.invoice.recognitionnew.model.RecognitionResult;
import kd.imc.rim.common.message.exception.MsgException;
import kd.imc.rim.common.utils.AwsFpyService;
import kd.imc.rim.common.utils.HttpUtil;
import kd.imc.rim.common.utils.ImcConfigUtil;
import kd.imc.rim.utils.ApiHttpUtils;
import kd.imc.rim.utils.FileOutputStreamExample;
import org.apache.commons.compress.utils.Lists;

public class AwsRecognitionServiceEx implements RecognitionService {
    private static Log logger = LogFactory.getLog(AwsRecognitionServiceEx.class);
    private static final int connectionTimeout = 3000;
    private static final int readTimeout = 60000;

    public AwsRecognitionServiceEx() {
    }

    public RecognitionResult recognitionInvoice(RecognitionParam recognitionParam) {
        RecognitionResult recognitionResult = this.getResultFromDb(recognitionParam);
        if (recognitionResult == null) {
            recognitionResult = this.getResultFromAws(recognitionParam);
        }

        return recognitionResult;
    }

    private RecognitionResult getResultFromAws(RecognitionParam recognitionParam) {
        RecognitionResult recognitionResult = new RecognitionResult();
        Map<String, Object> extMap = recognitionParam.getExtMap();
        Map<String, Object> bodyMap = Maps.newHashMap();
        bodyMap.put("eid", extMap.get("eid") + "");
        bodyMap.put("taxNo", extMap.get("taxNo") + "");
        bodyMap.put("recogType", recognitionParam.getRecogType());
        bodyMap.put("overseaAppCode", recognitionParam.getAppCode());
        String fileUrl = recognitionParam.getFileUrl();
        String imgStrToBase64 = FileOutputStreamExample.getImgStrToBase64(fileUrl);
        try {
            String serviceType = this.getServiceType(recognitionParam);
            Map<String, String> headers = Maps.newHashMap();
            boolean overseaFlag = false;
            if (!"".equals(imgStrToBase64)) {
                long start = System.currentTimeMillis();
                String url = "http://10.3.2.70:8115";
                String valueFileName;
                ByteArrayInputStream valueInputStream = recognitionParam.getFileByteArrayInputStream();
                valueFileName = recognitionParam.getFileName();
                int retryTimes = 1;
                for(int times = 1; times <= retryTimes; ++times) {
                    logger.info("aws识别bodyMap:{}", bodyMap);
                    String result = ApiHttpUtils.Posthttp(url, imgStrToBase64);
                    logger.info("aws识别接口返回结果{}：{}", times, result);
                    boolean reTry = false;
                    if (!StringUtils.isNotEmpty(result)) {
                        break;
                    }

                    JSONArray recognitionArray = this.getRecoginitionData(recognitionResult, result, overseaFlag);
                    if (recognitionArray == null) {
                        break;
                    }

                    boolean saveFlag = true;

                    for(int i = 0; i < recognitionArray.size(); ++i) {
                        JSONObject invoiceInfo = recognitionArray.getJSONObject(i);
                        if ("1".equals(invoiceInfo.getString("defaultOther"))) {
                            saveFlag = false;
                            if (times < retryTimes) {
                                reTry = true;
                                throw new MsgException("0002", ResManager.loadKDString("aws识别异常", "AwsRecognitionService_0", "imc-rim-common", new Object[0]));
                            }
                        }

                        this.setResultValue(invoiceInfo);
                    }

                    if (!reTry) {
                        if (saveFlag) {
                            this.saveRecognition(recognitionParam, serviceType, result, System.currentTimeMillis() - start);
                        }

                        recognitionResult.setData(this.convertRecognition(recognitionArray));
                        break;
                    }
                }
            } else {
                recognitionResult.setData(new ArrayList(1));
            }

            return recognitionResult;
        } catch (Throwable var22) {
            logger.error("AwsRecognitionService exception:", var22);
            if (var22 instanceof MsgException) {
                throw new MsgException(((MsgException)var22).getErrorCode(), ((MsgException)var22).getErrorMsg());
            } else {
                throw new MsgException("0001", ResManager.loadKDString("aws识别异常", "AwsRecognitionService_0", "imc-rim-common", new Object[0]));
            }
        }
    }

    private RecognitionResult getResultFromDb(RecognitionParam recognitionParam) {
        RecognitionResult recognitionResult = new RecognitionResult();
        String serviceType = this.getServiceType(recognitionParam);
        String resultStr = this.getRecognitionResultFromDb(recognitionParam, serviceType);
        if (StringUtils.isEmpty(resultStr)) {
            return null;
        } else {
            boolean overseaFlag = false;
            if (!resultStr.contains("recoginitionData")) {
                overseaFlag = true;
            }

            JSONArray recognitionArray = this.getRecoginitionData(recognitionResult, resultStr, overseaFlag);
            if (recognitionArray == null) {
                return null;
            } else {
                for(int i = 0; i < recognitionArray.size(); ++i) {
                    JSONObject invoiceInfo = recognitionArray.getJSONObject(i);
                    this.setResultValue(invoiceInfo);
                }

                recognitionResult.setData(this.convertRecognition(recognitionArray));
                return recognitionResult;
            }
        }
    }

    private JSONArray getRecoginitionData(RecognitionResult recognitionResult, String resultStr, boolean overseaFlag) {
        if (StringUtils.isNotEmpty(resultStr)) {
            JSONObject recognitionJson = JSONObject.parseObject(resultStr);
            recognitionResult.setErrcode(recognitionJson.getString("errcode"));
            recognitionResult.setDescription(recognitionJson.getString("description"));

            try {
                if (overseaFlag) {
                    JSONArray data = recognitionJson.getJSONArray("data");

                    for(int i = 0; i < data.size(); ++i) {
                        JSONObject overseaInfo = data.getJSONObject(i);
                        overseaInfo.put("invoiceType", InputInvoiceTypeEnum.OVERSEA_INVOICE.getAwsType());
                    }

                    return data;
                }

                JSONObject data = recognitionJson.getJSONObject("data");
                if (data != null) {
                    return data.getJSONArray("recoginitionData");
                }
            } catch (Exception var8) {
                logger.info("getRecoginitionData exception:", var8);
            }
        }

        return null;
    }

    private void setResultValue(JSONObject invoiceInfo) {
        invoiceInfo.put("snapshotUrl", "");
        invoiceInfo.put("kdcloudUrl", "");
        invoiceInfo.put("downloadUrl", "");
        Long invoiceType = InputInvoiceTypeEnum.getInvoiceTypeByAwsType(invoiceInfo.getString("invoiceType"));
        invoiceInfo.put("invoiceType", invoiceType);
        if (InputInvoiceTypeEnum.AIR_INVOICE.getCode().equals(invoiceType)) {
            JSONArray items = invoiceInfo.getJSONArray("items");
            if (items != null && items.size() > 0) {
                JSONObject firstOne = items.getJSONObject(0);
                invoiceInfo.put("seatGrade", firstOne.getString("seatGrade"));
                invoiceInfo.put("flightNum", firstOne.getString("flightNum"));
                invoiceInfo.put("seatGradeName", AirConvertService.convertSeatName(firstOne.getString("seatGrade")));
            }
        }

    }

    private List<Object> convertRecognition(JSONArray recognitionArray) {
        List<Object> entityList = Lists.newArrayList();
        ConvertFieldUtil.convertRecognitionEntity(entityList, recognitionArray, new String[]{"items"});
        return entityList;
    }

    public String getServiceType(RecognitionParam recognitionParam) {
        return "aws" + recognitionParam.getRecogType();
    }
}
